import { createSlice } from '@reduxjs/toolkit'
import { ToastType } from '../types/toastType'

const initialState: ToastType = {
  type: null,
  message: ''
}

const alertReducer = createSlice({
  name: 'alert',
  initialState: initialState,
  reducers: {
    info: (state, payload) => {
      state.type = 'info'
      state.message = payload.payload
      state.promise = undefined
      state.config = undefined
    },
    setError: (state, payload) => {
      state.type = 'error'
      state.message = payload.payload
      state.promise = undefined
      state.config = undefined
    },
    warning: (state, payload) => {
      state.type = 'warning'
      state.message = payload.payload
      state.promise = undefined
      state.config = undefined
    },
    success: (state, payload) => {
      state.type = 'success'
      state.message = payload.payload
      state.promise = undefined
      state.config = undefined
    },
    promise: (state, payload) => {
      state.type = 'promise'
      state.promise = payload.payload.promise
      state.config = payload.payload.config
    }
  }
})

export const { info, setError, success, warning, promise } = alertReducer.actions

export default alertReducer.reducer
